// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionSimple.h"
#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"

varying highp vec3 w_pos;
varying vec4 color;

void main()
{

highp vec3 posc = (w_pos.xyz/(w_pos.y-0.16));
float rd = length(posc.xz);

vec4 fc = FOG_COLOR;
vec4 cc = CURRENT_COLOR;

float dusk=pow(max(min(1.0-cc.b*1.2,1.0),0.0),0.5);
float night =pow(max(min(1.0-cc.r*1.5,1.0),0.0),0.3);
float rain=(1.0-pow(FOG_CONTROL.y,2.0));

vec4 lday2 = vec4(cc);
vec4 ldusk2 = vec4(0.7,0.4,0.2,1.0)*fc;
vec4 lnight2 = vec4(0.1,0.2,0.35,0.8);
vec4 lrain2 = vec4(cc);

vec4 dayl2 = mix(lday2,ldusk2,dusk);
vec4 nightl2 = mix(dayl2,lnight2,night);
vec4 rainl2 = mix(nightl2,lrain2,rain);
vec4 lengthC2 = rainl2;

vec4 lday3 = vec4(cc);
vec4 ldusk3 = vec4(0.36,0.15,0.05,1.0)*fc;
vec4 lnight3 = vec4(0.09,0.1,0.25,1.0);
vec4 lrain3 = vec4(cc);

vec4 dayl3 = mix(lday3,ldusk3,dusk);
vec4 nightl3 = mix(dayl3,lnight3,night);
vec4 rainl3 = mix(nightl3,lrain3,rain);
vec4 lengthC3 = rainl3;

vec4 lday4 = vec4(cc);
vec4 ldusk4 = vec4(0.3,0.05,0.0,1.0)*fc;
vec4 lnight4 = vec4(0.05,0.06,0.095,1.0);
vec4 lrain4 = vec4(cc);

vec4 dayl4 = mix(lday4,ldusk4,dusk);
vec4 nightl4 = mix(dayl4,lnight4,night);
vec4 rainl4 = mix(nightl4,lrain4,rain);
vec4 lengthC4 = rainl4;

vec4 cube_color= mix(vec4(lengthC4),cc,pow(clamp(rd*0.5,0.0,1.0),0.8));
cube_color = mix( cube_color,vec4(lengthC3), pow(clamp(rd*0.4,0.0,1.0),0.9));
cube_color = mix( cube_color,vec4(lengthC2), pow(clamp(rd*0.2,0.0,1.0),1.1));

FragColor = cube_color;
FragColor.a = 0.5*smoothstep(0.0, 0.95, dusk);

}